
%global server_name localhost
%global use_rcp 0
%global use_tcl 1
%global build_gui 1

%global torquehomedir %{_localstatedir}/lib/torque

%{?_with_rcp: %{?_without_rcp: %{error: both _with_rcp and _without_rcp}}}
%{?_with_tcl: %{?_without_tcl: %{error: both _with_tcl and _without_tcl}}}
%{?_with_gui: %{?_without_gui: %{error: both _with_gui and _without_gui}}}
%{?_with_rcp: %global use_rcp 1}
%{?_with_tcl: %global use_tcl 1}
%{?_with_gui: %global build_gui 1}
%{?_with_server_name:%global server_name %(set -- %{_with_server_name}; echo $1 | grep -v with | sed 's/=//')}
%{?_with_homedir:%global torquehomedir %(set -- %{_with_homedir}; echo $1 | grep -v with | sed 's/=//')}
%{?_without_rcp: %global use_rcp 0}
%{?_without_tcl: %global use_tcl 0}
%{?_without_gui: %global build_gui 0}

%global rcpflags    --with-rcp=/usr/bin/scp
%global tclflags    --without-tcl
%global guiflags    --disable-gui

%if %{use_rcp}
%global rcpflags    --with-rcp=mom_rcp
%endif

%if %{build_gui}
%global guiflags   --enable-gui
%endif

%if %{use_tcl}
%if %{build_gui}
%global tclflags    --with-tcl --with-tk
%else
%global tclflags    --with-tcl --without-tk
%endif
%endif

%global server_nameflags --with-default-server=%{server_name}

Summary:     Tera-scale Open-source Resource and QUEue manager
Name:        torque
Version:     6.1.3
Release:     6%{?dist}
License:     OpenPBS and TORQUEv1.1
URL:         https://github.com/adaptivecomputing/torque/
# git clone https://github.com/adaptivecomputing/torque.git
# git checkout -b 6.1.3
# tar acvf torque-6.1.3.tar.xz torque
Source0:    http://www.adaptivecomputing.com/download/%{name}/%{name}-%{version}.tar.xz
Source1:    config
Source2:    xpbs.desktop
Source3:    xpbsmon.desktop
Source4:    xpbs.png
Source5:    xpbsmon.png
Source6:    README.OpenCloudOS
Source7:    pbs_mom.service
Source8:    pbs_sched.service
Source9:    pbs_server.service
Source10:   trqauthd.service
Source11:   mom.layout

Patch3001:      torque-munge-size.patch
Patch3002:      torque-6.1.3-port-args.patch
Patch3003:      torque-6.1.3-autoconf-fixes.patch
Patch3004:      torque-6.1.3-system-jsoncpp.patch
Patch3005:      torque-6.1.3-bool-fix.patch


BuildRequires: make, gcc-c++, boost-devel, jsoncpp-devel, autoconf, automake, libtool
BuildRequires: pam-devel, xauth
BuildRequires: readline-devel, ncurses-devel, openssl-devel, hwloc-devel, libxml2-devel, munge-devel, gperf
BuildRequires: desktop-file-utils
BuildRequires: doxygen

%if %{use_tcl}
BuildRequires: tcl-devel
%endif
%if %{build_gui}
BuildRequires: tk-devel
%endif

%{?systemd_requires}
BuildRequires: systemd

Requires:       munge
Requires(post): %{_bindir}/grep %{_bindir}/cat /etc/services

%description
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds just a few shared files and directories.

%package         client
Summary:         Client part of TORQUE
Requires:        torque-libs = %{version}-%{release}
Requires(posttrans):  %{_sbindir}/alternatives
Requires(preun):      %{_sbindir}/alternatives

%description client
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the command-line client programs.

%package docs
Summary:        Documentation files for TORQUE
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description docs
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the documentation files.

%package gui
Summary:      Graphical clients for TORQUE
Requires:     torque-client = %{version}-%{release}
Requires:     torque-libs = %{version}-%{release}

%description gui
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the graphical clients.

%package libs
Summary:      Run-time libs for programs which will use the %{name} library
Requires:     munge
Provides:     libtorque = %{version}-%{release}
Requires:     munge

%description libs
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package includes the shared libraries necessary for running TORQUE 
programs.

%package devel
Summary:     Development tools for programs which will use the %{name} library
Requires:    torque-libs = %{version}-%{release}
Provides:    libtorque-devel = %{version}-%{release}

%description devel
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package includes the header files and static libraries
necessary for developing programs which will use %{name}.

%package mom
Summary:        Node execution daemon for TORQUE
Requires:       torque-libs = %{version}-%{release}
Requires:       munge
%if ! %{use_rcp}
Requires:       openssh-clients
%endif
Requires(posttrans):  systemd
Requires(preun):      systemd

%description mom
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the execute daemon required on every node.

%package pam
Summary:    PAM module for TORQUE MOM nodes

%description pam
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

A simple PAM module to authorize users on PBS MOM nodes with a running job.

%package scheduler
Summary:         Simple fifo scheduler for TORQUE
Requires:        torque-libs = %{version}-%{release}
Requires(posttrans):  systemd
Requires(preun):      systemd

%description scheduler
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the fifo C scheduler.

%package server
Summary:           The main part of TORQUE
Requires:          torque-libs = %{version}-%{release}
Requires:          munge
%if ! %{use_rcp}
Requires:          openssh-server
%endif
Requires(posttrans):  systemd
Requires(preun):      systemd

%description server
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

This package holds the server.

%package drmaa
Summary:           Run time files for the drmaa interface
Requires:          torque-libs = %{version}-%{release}

%description drmaa
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

Run time files for working the DRMAA interface to torque.
DRMAA is "Distributed Resource Management Application API"


%package drmaa-devel
Summary:           Development files for the drmaa interface.
Requires:          torque-drmaa = %{version}-%{release}
Requires:          torque-devel = %{version}-%{release}

%description drmaa-devel
TORQUE (Tera-scale Open-source Resource and QUEue manager) is a resource 
manager providing control over batch jobs and distributed compute nodes.
TORQUE is based on OpenPBS version 2.3.12 and incorporates scalability,
fault tolerance, and feature extension patches provided by USC, NCSA, OSC,
the U.S. Dept of Energy, Sandia, PNNL, U of Buffalo, TeraGrid, and many
other leading edge HPC organizations.

Developement files for working the DRMAA interface to torque.
DRMAA is "Distributed Resource Management Application API"



%prep
%autosetup -p1 -n torque
rm -rf src/lib/Libutils/jsoncpp.cpp src/include/json
sed -i '/LATEX_BATCHMODE/d' src/drmaa/Doxyfile.in
install -pm 644 %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE1} .



%build
autoreconf -ifv

CFLAGS="%{optflags} -DUSE_INTERP_RESULT -DUSE_INTERP_ERRORLINE -fpermissive"
%configure --includedir=%{_includedir}/torque \
  --with-server-home=%{torquehomedir} --with-pam=/%{_lib}/security \
  --with-sendmail=%{_sbindir}/sendmail --disable-static \
  --with-tcp-retry-limit=2 --without-debug \
  --enable-drmaa --enable-munge-auth --with-munge \
  --enable-cpuset --enable-numa-support \
  %{server_nameflags} %{guiflags} %{tclflags} %{rcpflags}

make %{?_smp_mflags} CC=g++

for daemon in pbs_mom pbs_sched pbs_server trqauthd
do
sed -i -e 's|^PBS_HOME=.*|PBS_HOME=%{torquehomedir}|' \
       -e 's|^PBS_DAEMON=.*|PBS_DAEMON=%{_sbindir}/'$daemon'|' \
       -e 's|chkconfig: 345|chkconfig: -|' \
       contrib/init.d/$daemon
done



%install
make DESTDIR=%{buildroot} INSTALL="install -p" install

pushd src/drmaa
doxygen
install -p doc/man/man3/*.3 %{buildroot}%{_mandir}/man3/
popd

rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/*/buildindex
rm -f %{buildroot}/%{_lib}/security/pam_pbssimpleauth.{a,la}
mkdir -p %{buildroot}%{_bindir}

mkdir -p %{buildroot}%{_unitdir}
install -p -m 644 %{SOURCE7} %{buildroot}%{_unitdir}/
install -p -m 644 %{SOURCE8} %{buildroot}%{_unitdir}/
install -p -m 644 %{SOURCE9} %{buildroot}%{_unitdir}/
install -p -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/

rm -rf %{buildroot}%{_sysconfdir}/init.d

%if %{build_gui}
sed -i -e 's|%{_lib}/../||' %{buildroot}%{_bindir}/xpbs
desktop-file-install --dir %{buildroot}%{_datadir}/applications --vendor=adaptivecomputing.com xpbs.desktop
desktop-file-install --dir %{buildroot}%{_datadir}/applications --vendor=adaptivecomputing.com xpbsmon.desktop
install -d %{buildroot}%{_datadir}/pixmaps
install -p -m0644 xpbs.png xpbsmon.png %{buildroot}%{_datadir}/pixmaps
%endif

for bin in qalter qdel qhold qrls qselect qstat qsub
do
    mv %{buildroot}%{_bindir}/$bin %{buildroot}%{_bindir}/${bin}-torque
    mv %{buildroot}%{_mandir}/man1/${bin}.1 \
       %{buildroot}%{_mandir}/man1/${bin}-torque.1
done

rm %{buildroot}/%{torquehomedir}/server_priv/nodes

mkdir -p %{buildroot}%{_sysconfdir}/torque
pushd %{buildroot}%{torquehomedir}
mv pbs_environment %{buildroot}%{_sysconfdir}/torque
mv server_name %{buildroot}%{_sysconfdir}/torque
ln -s %{_sysconfdir}/torque/pbs_environment .
ln -s %{_sysconfdir}/torque/server_name .
popd

mkdir -p %{buildroot}%{_var}/log/torque
pushd %{buildroot}%{torquehomedir}
mv mom_logs %{buildroot}%{_var}/log/torque
ln -s %{_var}/log/torque/mom_logs .
popd

mkdir -p %{buildroot}%{_sysconfdir}/torque/mom
install -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/torque/mom/config
install -p -m 644 %{SOURCE11} %{buildroot}%{_sysconfdir}/torque/mom/mom.layout
pushd %{buildroot}%{torquehomedir}/mom_priv
ln -s %{_sysconfdir}/torque/mom/config .
ln -s %{_sysconfdir}/torque/mom/mom.layout .
popd

mkdir -p %{buildroot}%{_sysconfdir}/torque/sched
pushd %{buildroot}%{torquehomedir}/sched_priv
for CONFIG in dedicated_time holidays resource_group sched_config ; do
  mv $CONFIG %{buildroot}%{_sysconfdir}/torque/sched/.
  ln -s %{_sysconfdir}/torque/sched/$CONFIG .
done
popd

pushd %{buildroot}%{torquehomedir}
mv sched_logs %{buildroot}%{_var}/log/torque
ln -s %{_var}/log/torque/sched_logs .
popd

pushd %{buildroot}%{torquehomedir}
mv server_logs %{buildroot}%{_var}/log/torque
ln -s %{_var}/log/torque/server_logs .
popd


rm %{buildroot}%{_mandir}/man1/basl2c.1

chmod 755 `find %{buildroot}/var/lib/torque -type d`

rm -rf %{buildroot}%{_sysconfdir}/ld.so.conf.d

rm -rf %{buildroot}%{_sysconfdir}/profile.d

rm -rf %{buildroot}%{_datadir}/doc/torque-drmaa

%post
sed -i '/pbs_mon/D' /etc/services
for srvs in pbs:15001 pbs_mom:15002 pbs_resmom:15003 pbs_sched:15004 ; do
  port=${srvs/*:/}
  srvs=${srvs/:*/}
  for proto in tcp udp ; do
    if ! grep -q $srvs'\W\W*'$port'/'$proto /etc/services;then
      cat<<__EOF__>>/etc/services
$srvs        $port/$proto
__EOF__
    fi
  done
done

%systemd_post trqauthd.service


%preun
%systemd_preun trqauthd.service

%posttrans client
/usr/sbin/alternatives --install %{_bindir}/qsub qsub %{_bindir}/qsub-torque 10 \
        --slave %{_mandir}/man1/qsub.1.gz qsub-man \
                %{_mandir}/man1/qsub-torque.1.gz \
        --slave %{_bindir}/qalter qalter %{_bindir}/qalter-torque \
        --slave %{_mandir}/man1/qalter.1.gz qalter-man \
                %{_mandir}/man1/qalter-torque.1.gz \
        --slave %{_bindir}/qdel qdel %{_bindir}/qdel-torque \
        --slave %{_mandir}/man1/qdel.1.gz qdel-man \
                %{_mandir}/man1/qdel-torque.1.gz \
        --slave %{_bindir}/qhold qhold %{_bindir}/qhold-torque \
        --slave %{_mandir}/man1/qhold.1.gz qhold-man \
                %{_mandir}/man1/qhold-torque.1.gz \
        --slave %{_bindir}/qrls qrls %{_bindir}/qrls-torque \
        --slave %{_mandir}/man1/qrls.1.gz qrls-man \
                %{_mandir}/man1/qrls-torque.1.gz \
        --slave %{_bindir}/qselect qselect %{_bindir}/qselect-torque \
        --slave %{_mandir}/man1/qselect.1.gz qselect-man \
                %{_mandir}/man1/qselect-torque.1.gz \
        --slave %{_bindir}/qstat qstat %{_bindir}/qstat-torque \
        --slave %{_mandir}/man1/qstat.1.gz qstat-man \
                %{_mandir}/man1/qstat-torque.1.gz

%preun client
if [ $1 -eq 0 ]; then
  /usr/sbin/alternatives --remove qsub %{_bindir}/qsub-torque
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post drmaa -p /sbin/ldconfig

%postun drmaa -p /sbin/ldconfig

%pre mom
if test -f %{torquehomedir}/mom_priv/mom.layout ; then
  if ! test -h %{torquehomedir}/mom_priv/mom.layout ; then
    mkdir -p %{_sysconfdir}/torque/mom
    cp -p %{torquehomedir}/mom_priv/mom.layout %{_sysconfdir}/torque/mom/
  fi
fi

%post mom
%systemd_post pbs_mom.service

%preun mom
%systemd_preun pbs_mom.service

%post scheduler
%systemd_post pbs_sched.service

%preun scheduler
%systemd_preun pbs_sched.service

%post server
%systemd_post pbs_server.service

%preun server
%systemd_preun pbs_server.service



%files
%license PBS_License.txt contrib/PBS_License_2.3.txt
%doc README.torque torque.setup Release_Notes 
%doc CHANGELOG README.OpenCloudOS 
%dir %{torquehomedir} 
%dir %{torquehomedir}/aux
%attr (1777,root,root) %{torquehomedir}/spool
%attr (1777,root,root) %{torquehomedir}/undelivered
%attr (1777,root,root) %{torquehomedir}/checkpoint
%dir %{torquehomedir}/spool
%dir %{torquehomedir}/undelivered
%{torquehomedir}/checkpoint
%{torquehomedir}/pbs_environment
%{torquehomedir}/server_name
%config(noreplace) %{_sysconfdir}/torque/pbs_environment
%config(noreplace) %{_sysconfdir}/torque/server_name
%{_mandir}/man1/pbs.1.*
%attr(0755, root, root) %{_sbindir}/trqauthd
%{_unitdir}/trqauthd.service

%files client
%{_bindir}/q*
%{_bindir}/chk_tree
%{_bindir}/hostn
%{_bindir}/nqs2pbs
%{_bindir}/pbsdsh
%{_bindir}/pbsnodes
%{_bindir}/printjob
%{_bindir}/printserverdb
%{_bindir}/printtracking
%{_bindir}/tracejob
%{_sbindir}/pbs_demux
%if %{use_tcl}
%{_bindir}/pbs_tclsh
%endif
%{_mandir}/man1/nqs2pbs.1.*
%{_mandir}/man1/pbsdsh.1.*
%{_mandir}/man1/qchkpt.1.*
%{_mandir}/man1/qmgr.1.*
%{_mandir}/man1/qmove.1.*
%{_mandir}/man1/qmsg.1.*
%{_mandir}/man1/qorder.1.*
%{_mandir}/man1/qrerun.1.*
%{_mandir}/man1/qsig.1.*
%{_mandir}/man1/qgpumode.1.gz
%{_mandir}/man1/qgpureset.1.gz
%{_mandir}/man8/pbsnodes.8.*
%{_mandir}/man8/qdisable.8.*
%{_mandir}/man8/qenable.8.*
%{_mandir}/man8/qrun.8.*
%{_mandir}/man8/qstart.8.*
%{_mandir}/man8/qstop.8.*
%{_mandir}/man8/qterm.8.*
%{_mandir}/man7/pbs_job_attributes.7.*
%{_mandir}/man7/pbs_queue_attributes.7.*
%{_mandir}/man7/pbs_resources.7.*
%{_mandir}/man7/pbs_resources_aix4.7.*
%{_mandir}/man7/pbs_resources_aix5.7.*
%{_mandir}/man7/pbs_resources_darwin.7.*
%{_mandir}/man7/pbs_resources_digitalunix.7.*
%{_mandir}/man7/pbs_resources_freebsd.7.*
%{_mandir}/man7/pbs_resources_fujitsu.7.*
%{_mandir}/man7/pbs_resources_hpux10.7.*
%{_mandir}/man7/pbs_resources_hpux11.7.*
%{_mandir}/man7/pbs_resources_irix5.7.*
%{_mandir}/man7/pbs_resources_irix6.7.*
%{_mandir}/man7/pbs_resources_irix6array.7.*
%{_mandir}/man7/pbs_resources_linux.7.*
%{_mandir}/man7/pbs_resources_netbsd.7.*
%{_mandir}/man7/pbs_resources_solaris5.7.*
%{_mandir}/man7/pbs_resources_solaris7.7.*
%{_mandir}/man7/pbs_resources_sp2.7.*
%{_mandir}/man7/pbs_resources_sunos4.7.*
%{_mandir}/man7/pbs_resources_unicos8.7.*
%{_mandir}/man7/pbs_resources_unicosmk2.7.*
%{_mandir}/man7/pbs_server_attributes.7.*
%{_mandir}/man1/qsub-torque.1.*
%{_mandir}/man1/qalter-torque.1.*
%{_mandir}/man1/qdel-torque.1.*
%{_mandir}/man1/qhold-torque.1.*
%{_mandir}/man1/qrls-torque.1.*
%{_mandir}/man1/qselect-torque.1.*
%{_mandir}/man1/qstat-torque.1.*


%files docs
%doc doc/admin_guide.ps

%if %{build_gui}
%files gui
%{_bindir}/pbs_wish
%{_bindir}/xpbs
%{_bindir}/xpbsmon
%{_libdir}/xpbs
%{_libdir}/xpbsmon
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/*.png
%{_mandir}/man1/xpbs.1.*
%{_mandir}/man1/xpbsmon.1.*
%endif

%files libs
%{_libdir}/libtorque.so.*

%files devel
%{_libdir}/libtorque.so
%{_includedir}/torque
%exclude %{_includedir}/torque/drmaa.h
%{_bindir}/pbs-config
%{_mandir}/man3/pbs_alterjob.3.*
%{_mandir}/man3/pbs_connect.3.*
%{_mandir}/man3/pbs_default.3.*
%{_mandir}/man3/pbs_deljob.3.*
%{_mandir}/man3/pbs_disconnect.3.*
%{_mandir}/man3/pbs_geterrmsg.3.*
%{_mandir}/man3/pbs_holdjob.3.*
%{_mandir}/man3/pbs_locate.3.*
%{_mandir}/man3/pbs_manager.3.*
%{_mandir}/man3/pbs_movejob.3.*
%{_mandir}/man3/pbs_msgjob.3.*
%{_mandir}/man3/pbs_orderjob.3.*
%{_mandir}/man3/pbs_rerunjob.3.*
%{_mandir}/man3/pbs_rescquery.3.*
%{_mandir}/man3/pbs_rescreserve.3.*
%{_mandir}/man3/pbs_rlsjob.3.*
%{_mandir}/man3/pbs_runjob.3.*
%{_mandir}/man3/pbs_selectjob.3.*
%{_mandir}/man3/pbs_selstat.3.*
%{_mandir}/man3/pbs_sigjob.3.*
%{_mandir}/man3/pbs_stagein.3.*
%{_mandir}/man3/pbs_statjob.3.*
%{_mandir}/man3/pbs_statnode.3.*
%{_mandir}/man3/pbs_statque.3.*
%{_mandir}/man3/pbs_statserver.3.*
%{_mandir}/man3/pbs_submit.3.*
%{_mandir}/man3/pbs_terminate.3.*
%{_mandir}/man3/pbs_checkpointjob.3.gz
%{_mandir}/man3/pbs_fbserver.3.gz
%{_mandir}/man3/pbs_get_server_list.3.gz
%{_mandir}/man3/pbs_gpumode.3.gz
%{_mandir}/man3/pbs_gpureset.3.gz
%{_mandir}/man3/tm.3.*

%files mom
%{_sbindir}/momctl
%{_sbindir}/pbs_mom
%{_sbindir}/qnoded
%{_sbindir}/pbs_demux
%{_bindir}/pbs_track
%{_unitdir}/pbs_mom.service
%if %{use_rcp}
%attr(4755, root, root) %{_sbindir}/pbs_rcp
%endif
%{torquehomedir}/mom_priv
%{torquehomedir}/mom_logs
%dir %{_var}/log/torque
%dir %{_var}/log/torque/mom_logs
%dir %{_sysconfdir}/torque/mom
%{_mandir}/man8/pbs_mom.8.*
%config(noreplace) %{_sysconfdir}/torque/mom/config
%config(noreplace) %{_sysconfdir}/torque/mom/mom.layout

%files pam
%doc src/pam/README.pam
/%{_lib}/security/pam_pbssimpleauth.so

%files scheduler
%attr(0755, root, root) %{_sbindir}/pbs_sched
%{_sbindir}/qschedd
%{_unitdir}/pbs_sched.service
%dir %{torquehomedir}/sched_priv
%config(noreplace) %{torquehomedir}/sched_priv/*
%{torquehomedir}/sched_logs
%dir %{_var}/log/torque/sched_logs
%dir %{_sysconfdir}/torque/sched
%{_mandir}/man8/pbs_sched.8.*
%{_mandir}/man8/pbs_sched_basl.8.*
%{_mandir}/man8/pbs_sched_cc.8.*
%{_mandir}/man8/pbs_sched_tcl.8.*
%config(noreplace) %{_sysconfdir}/torque/sched/dedicated_time 
%config(noreplace) %{_sysconfdir}/torque/sched/holidays 
%config(noreplace) %{_sysconfdir}/torque/sched/resource_group 
%config(noreplace) %{_sysconfdir}/torque/sched/sched_config 

%files server
%attr(0755, root, root) %{_sbindir}/pbs_server
%{_sbindir}/qserverd
%{_unitdir}/pbs_server.service
%dir %{_var}/log/torque/server_logs
%{torquehomedir}/server_logs
%{torquehomedir}/server_priv
%{_mandir}/man8/pbs_server.8.*

%files drmaa
%{_libdir}/libdrmaa.so.*

%files drmaa-devel
%{_libdir}/libdrmaa.so
%{_includedir}/torque/drmaa.h
%{_mandir}/man3/compat.h.3.*
%{_mandir}/man3/drmaa.3.*
%{_mandir}/man3/drmaa.h.3.*
%{_mandir}/man3/drmaa_attrib.3.*
%{_mandir}/man3/drmaa_attrib_info_s.3.*
%{_mandir}/man3/drmaa_def_attr_s.3.*
%{_mandir}/man3/drmaa_job_iter_s.3.*
%{_mandir}/man3/drmaa_job_s.3.*
%{_mandir}/man3/drmaa_jobt.3.*
%{_mandir}/man3/drmaa_viter.3.*
%{_mandir}/man3/pbs_attrib.3.*
%{_mandir}/man3/error.h.3.*
%{_mandir}/man3/jobs.3.*
%{_mandir}/man3/jobs.h.3.*
%{_mandir}/man3/lookup3.h.3.*



%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.1.3-6
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 6.1.3-5
- Rebuilt for tcl 8.6.13

* Tue Aug 01 2023 rockerzhu rockerzhu@tencent.com - 6.1.3-4
- Rebuilt for boost 1.82.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.1.3-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.1.3-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 29 2023 Zhao Zhen <jeremiazhao@tencent.com> - 6.1.3-1
- initial
